Index: gnu/usr.bin/perl/pod/perlhist.pod
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/pod/perlhist.pod,v
diff -u -p -a -u -p -r1.32 perlhist.pod
--- gnu/usr.bin/perl/pod/perlhist.pod	26 Dec 2025 22:14:21 -0000	1.32
+++ gnu/usr.bin/perl/pod/perlhist.pod	29 Mar 2026 16:31:45 -0000
@@ -1244,6 +1280,8 @@ the Perl source distribution for somewha
  win32       1313     65      1326     65      1331     65
  x2p            -      -         -      -         -      -
 
+ ======================================================================
+
                   5.32.0           5.34.0           5.36.0
 
  Configure    588      1       592      1       603      1
@@ -1262,20 +1300,22 @@ the Perl source distribution for somewha
  vos           12      7        12      7         8      7
  win32       1011     47      1001     46       966     45
 
-                  5.38.0
+ ======================================================================
+
+                  5.38.0           5.40.0           5.42.0
 
- Configure    604      1
- Cross        122     15
- h2pl          13     15
- hints        358     83
- os2          538     70
- plan9        322     20
- Porting     1640     80
- qnx            1      4
- utils        606     52
- vms          544     12
- vos            8      7
- win32        982     45
+ Configure    604      1       613      1       613      1
+ Cross        122     15       126     15       126     15
+ h2pl          13     15        24     15        24     15
+ hints        358     83       362     84       362     84
+ os2          538     70       580     70       580     70
+ plan9        322     20       330     20       330     20
+ Porting     1640     80      1660     80      1670     78
+ qnx            1      4         5      4         5      4
+ utils        606     52       773     52       773     52
+ vms          544     12       548     12       547     12
+ vos            8      7        12      7        12      7
+ win32        982     45      1016     47      1025     47
 
 =head2 SELECTED PATCH SIZES
 
Index: gnu/usr.bin/perl/t/class/gh23511.t
===================================================================
RCS file: gnu/usr.bin/perl/t/class/gh23511.t
diff -N gnu/usr.bin/perl/t/class/gh23511.t
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gnu/usr.bin/perl/t/class/gh23511.t	29 Mar 2026 16:31:45 -0000
@@ -0,0 +1,23 @@
+#!./perl
+
+BEGIN {
+    chdir 't' if -d 't';
+    require './test.pl';
+    set_up_inc('../lib');
+}
+
+use v5.36;
+use feature 'class';
+no warnings 'experimental::class';
+
+# this used to segfault: GH #23511
+eval <<'CLASS';
+class MyTest {
+    $id = 6;
+    field $f1 :reader;
+    field $f2 :writer;
+}
+CLASS
+like $@, qr/^Global symbol "\$id" requires explicit package name /, "we get the expected 'undeclared variable' error";
+
+done_testing;
Index: gnu/usr.bin/perl/t/op/ref.t
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/t/op/ref.t,v
diff -u -p -a -u -p -r1.21 ref.t
--- gnu/usr.bin/perl/t/op/ref.t	28 Jan 2025 01:06:16 -0000	1.21
+++ gnu/usr.bin/perl/t/op/ref.t	29 Mar 2026 16:31:45 -0000
@@ -8,7 +8,7 @@ BEGIN {
 
 use strict qw(refs subs);
 
-plan(257);
+plan(265);
 
 # Test this first before we extend the stack with other operations.
 # This caused an asan failure due to a bad write past the end of the stack.
@@ -911,6 +911,47 @@ EOF
     my @exp = ("0") x $n;
     fresh_perl_is($code, "@exp", { stderr => 1 },
                     'rt#130861: heap uaf in pp_rv2sv');
+}
+
+# GH 18669
+# The correct autovivification lvalue ref context should be propagated to
+# both branches of a ?:. So in something like:
+#    @{  $cond ? $h{a} : $h{b} } = ...;
+# the helem ops on *both* sides of the conditional should get the DREFAV
+# flag set, indicating that if the hash element doesn't exist, it should
+# be autovivified as an *array ref*.
+#
+
+{
+    my $x = { arr => undef };
+    eval {
+        push(@{ $x->{ decide } ? $x->{ not_here } : $x->{ new } }, "mana");
+    };
+
+    is($@, "", "GH 18669: push on non-existent hash ref entry: no errors");
+    is(eval {$x->{new}[0] }, 'mana',
+        "GH 18669: push on non-existent hash ref entry: autovivifies"
+    );
+
+    $x = { arr => undef };
+    eval {
+        push(@{ $x->{ decide } ? $x->{ not_here } : $x->{ arr } }, "mana");
+    };
+
+    is($@, "", "GH 18669: push on undef hash ref entry: no errors");
+    is(eval { $x->{arr}[0] }, 'mana',
+        "GH 18669: push on undef hash ref entry: autovivifies"
+    );
+
+    # try both branches
+    for my $cond (0, 1) {
+        my %h;
+        eval { @{ $cond ? $h{p} : $h{q} } = 99; };
+        is($@, "", "GH 18669: array assign on $cond cond: no errors");
+        is($h{$cond ? 'p' : 'q'}[0], 99,
+            "GH 18669: array assign on $cond cond: autovivifies"
+        );
+    }
 }
 
 # Bit of a hack to make test.pl happy. There are 3 more tests after it leaves.
Index: gnu/usr.bin/perl/vms/descrip_mms.template
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/vms/descrip_mms.template,v
diff -u -p -a -u -p -r1.17 descrip_mms.template
--- gnu/usr.bin/perl/vms/descrip_mms.template	26 Dec 2025 22:14:22 -0000	1.17
+++ gnu/usr.bin/perl/vms/descrip_mms.template	29 Mar 2026 16:31:45 -0000
@@ -298,7 +298,7 @@ utils : $(utils1) $(utils2) $(utils3) $(
 extra.pods : miniperl
 	@ @extra_pods.com
 
-PERLDELTA_CURRENT = [.pod]perl5420delta.pod
+PERLDELTA_CURRENT = [.pod]perl5422delta.pod
 
 $(PERLDELTA_CURRENT) : [.pod]perldelta.pod
 	Copy/NoConfirm/Log $(MMS$SOURCE) $(PERLDELTA_CURRENT)
Index: gnu/usr.bin/perl/win32/GNUmakefile
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/win32/GNUmakefile,v
diff -u -p -a -u -p -r1.32 GNUmakefile
--- gnu/usr.bin/perl/win32/GNUmakefile	26 Dec 2025 22:16:26 -0000	1.32
+++ gnu/usr.bin/perl/win32/GNUmakefile	29 Mar 2026 16:31:45 -0000
@@ -63,7 +63,7 @@ INST_TOP := $(INST_DRV)\perl
 # versioned installation can be obtained by setting INST_TOP above to a
 # path that includes an arbitrary version string.
 #
-#INST_VER	:= \5.42.0
+#INST_VER	:= \5.42.2
 
 #
 # Comment this out if you DON'T want your perl installation to have
@@ -1644,7 +1644,7 @@ utils: $(HAVEMINIPERL) ..\utils\Makefile
 	copy ..\README.tw       ..\pod\perltw.pod
 	copy ..\README.vos      ..\pod\perlvos.pod
 	copy ..\README.win32    ..\pod\perlwin32.pod
-	copy ..\pod\perldelta.pod ..\pod\perl5420delta.pod
+	copy ..\pod\perldelta.pod ..\pod\perl5422delta.pod
 	$(MINIPERL) -I..\lib $(PL2BAT) $(UTILS)
 	$(MINIPERL) -I..\lib ..\autodoc.pl -c "win32\$(CONFIG_H)" ..
 	$(MINIPERL) -I..\lib ..\pod\perlmodlib.PL -q ..
@@ -1745,7 +1745,7 @@ distclean: realclean
 	-if exist $(LIBDIR)\Win32API rmdir /s /q $(LIBDIR)\Win32API
 	-if exist $(LIBDIR)\XS rmdir /s /q $(LIBDIR)\XS
 	-cd $(PODDIR) && del /f *.html *.bat roffitall \
-	    perl5420delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
+	    perl5422delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
 	    perlapi.pod perlbs2000.pod perlcn.pod perlcygwin.pod \
 	    perlfreebsd.pod perlhaiku.pod perlhpux.pod perlhurd.pod \
 	    perlintern.pod perlirix.pod perljp.pod perlko.pod perllinux.pod \
Index: gnu/usr.bin/perl/win32/Makefile
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/win32/Makefile,v
diff -u -p -a -u -p -r1.57 Makefile
--- gnu/usr.bin/perl/win32/Makefile	26 Dec 2025 22:16:26 -0000	1.57
+++ gnu/usr.bin/perl/win32/Makefile	29 Mar 2026 16:31:45 -0000
@@ -37,7 +37,7 @@ INST_TOP	= $(INST_DRV)\perl
 # versioned installation can be obtained by setting INST_TOP above to a
 # path that includes an arbitrary version string.
 #
-#INST_VER	= \5.42.0
+#INST_VER	= \5.42.2
 
 #
 # Comment this out if you DON'T want your perl installation to have
@@ -1171,7 +1171,7 @@ utils: $(PERLEXE) ..\utils\Makefile
 	copy ..\README.tw       ..\pod\perltw.pod
 	copy ..\README.vos      ..\pod\perlvos.pod
 	copy ..\README.win32    ..\pod\perlwin32.pod
-	copy ..\pod\perldelta.pod ..\pod\perl5420delta.pod
+	copy ..\pod\perldelta.pod ..\pod\perl5422delta.pod
 	cd ..\win32
 	$(PERLEXE) $(PL2BAT) $(UTILS)
 	$(MINIPERL) -I..\lib ..\autodoc.pl -c "win32\$(CONFIG_H)" ..
@@ -1273,7 +1273,7 @@ distclean: realclean
 	-if exist $(LIBDIR)\Win32API rmdir /s /q $(LIBDIR)\Win32API
 	-if exist $(LIBDIR)\XS rmdir /s /q $(LIBDIR)\XS
 	-cd $(PODDIR) && del /f *.html *.bat roffitall \
-	    perl5420delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
+	    perl5422delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
 	    perlapi.pod perlbs2000.pod perlcn.pod perlcygwin.pod \
 	    perlfreebsd.pod perlhaiku.pod perlhpux.pod perlhurd.pod \
 	    perlintern.pod perlirix.pod perljp.pod perlko.pod perllinux.pod \
Index: gnu/usr.bin/perl/win32/perllib.c
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/win32/perllib.c,v
diff -u -p -a -u -p -r1.18 perllib.c
--- gnu/usr.bin/perl/win32/perllib.c	26 Dec 2025 22:14:22 -0000	1.18
+++ gnu/usr.bin/perl/win32/perllib.c	29 Mar 2026 16:31:45 -0000
@@ -51,6 +51,7 @@ xs_init(pTHX)
 void
 win32_checkTLS(PerlInterpreter *host_perl)
 {
+#ifdef USE_ITHREADS
 /* GCurThdId() is lightweight, but b/c of the ctrl-c/signals sometimes firing
   in other random WinOS threads, that make the TIDs go out of sync.
   This isn't always an error, although high chance of a SEGV in the next
@@ -67,6 +68,13 @@ win32_checkTLS(PerlInterpreter *host_per
         }
         host_perl->Isys_intern.cur_tid = tid;
     }
+#else
+    dTHX;
+    if (host_perl != my_perl) {
+        int *nowhere = NULL;
+        abort();
+    }
+#endif
 }
 
 EXTERN_C void
Index: gnu/usr.bin/perl/win32/pod.mak
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/win32/pod.mak,v
diff -u -p -a -u -p -r1.32 pod.mak
--- gnu/usr.bin/perl/win32/pod.mak	26 Dec 2025 22:14:22 -0000	1.32
+++ gnu/usr.bin/perl/win32/pod.mak	29 Mar 2026 16:31:45 -0000
@@ -77,10 +77,14 @@ POD = perl.pod	\
 	perl5382delta.pod	\
 	perl5383delta.pod	\
 	perl5384delta.pod	\
+	perl5385delta.pod	\
 	perl5400delta.pod	\
 	perl5401delta.pod	\
 	perl5402delta.pod	\
+	perl5403delta.pod	\
 	perl5420delta.pod	\
+	perl5421delta.pod	\
+	perl5422delta.pod	\
 	perl561delta.pod	\
 	perl56delta.pod	\
 	perl581delta.pod	\
@@ -258,10 +262,14 @@ MAN = perl.man	\
 	perl5382delta.man	\
 	perl5383delta.man	\
 	perl5384delta.man	\
+	perl5385delta.man	\
 	perl5400delta.man	\
 	perl5401delta.man	\
 	perl5402delta.man	\
+	perl5403delta.man	\
 	perl5420delta.man	\
+	perl5421delta.man	\
+	perl5422delta.man	\
 	perl561delta.man	\
 	perl56delta.man	\
 	perl581delta.man	\
@@ -439,10 +447,14 @@ HTML = perl.html	\
 	perl5382delta.html	\
 	perl5383delta.html	\
 	perl5384delta.html	\
+	perl5385delta.html	\
 	perl5400delta.html	\
 	perl5401delta.html	\
 	perl5402delta.html	\
+	perl5403delta.html	\
 	perl5420delta.html	\
+	perl5421delta.html	\
+	perl5422delta.html	\
 	perl561delta.html	\
 	perl56delta.html	\
 	perl581delta.html	\
@@ -620,10 +632,14 @@ TEX = perl.tex	\
 	perl5382delta.tex	\
 	perl5383delta.tex	\
 	perl5384delta.tex	\
+	perl5385delta.tex	\
 	perl5400delta.tex	\
 	perl5401delta.tex	\
 	perl5402delta.tex	\
+	perl5403delta.tex	\
 	perl5420delta.tex	\
+	perl5421delta.tex	\
+	perl5422delta.tex	\
 	perl561delta.tex	\
 	perl56delta.tex	\
 	perl581delta.tex	\
